diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/query.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/query.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/query.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/query.php	2012-12-17 16:18:40.000000000 -0600
***************
*** 86,93 ****
   * @param string $query
   * @return array List of posts
   */
! function &query_posts($query) {
! 	unset($GLOBALS['wp_query']);
  	$GLOBALS['wp_query'] = new WP_Query();
  	return $GLOBALS['wp_query']->query($query);
  }
--- 86,92 ----
   * @param string $query
   * @return array List of posts
   */
! function query_posts($query) {
  	$GLOBALS['wp_query'] = new WP_Query();
  	return $GLOBALS['wp_query']->query($query);
  }
***************
*** 103,109 ****
   * @uses $wp_query
   */
  function wp_reset_query() {
- 	unset($GLOBALS['wp_query']);
  	$GLOBALS['wp_query'] = $GLOBALS['wp_the_query'];
  	wp_reset_postdata();
  }
--- 102,107 ----
***************
*** 128,134 ****
   */
  
  /**
!  * Is the query for an archive page?
   *
   * Month, Year, Category, Author, Post Type archive...
   *
--- 126,132 ----
   */
  
  /**
!  * Is the query for an existing archive page?
   *
   * Month, Year, Category, Author, Post Type archive...
   *
***************
*** 150,156 ****
  }
  
  /**
!  * Is the query for a post type archive page?
   *
   * @see WP_Query::is_post_type_archive()
   * @since 3.1.0
--- 148,154 ----
  }
  
  /**
!  * Is the query for an existing post type archive page?
   *
   * @see WP_Query::is_post_type_archive()
   * @since 3.1.0
***************
*** 171,177 ****
  }
  
  /**
!  * Is the query for an attachment page?
   *
   * @see WP_Query::is_attachment()
   * @since 2.0.0
--- 169,175 ----
  }
  
  /**
!  * Is the query for an existing attachment page?
   *
   * @see WP_Query::is_attachment()
   * @since 2.0.0
***************
*** 191,197 ****
  }
  
  /**
!  * Is the query for an author archive page?
   *
   * If the $author parameter is specified, this function will additionally
   * check if the query is for one of the authors specified.
--- 189,195 ----
  }
  
  /**
!  * Is the query for an existing author archive page?
   *
   * If the $author parameter is specified, this function will additionally
   * check if the query is for one of the authors specified.
***************
*** 215,221 ****
  }
  
  /**
!  * Is the query for a category archive page?
   *
   * If the $category parameter is specified, this function will additionally
   * check if the query is for one of the categories specified.
--- 213,219 ----
  }
  
  /**
!  * Is the query for an existing category archive page?
   *
   * If the $category parameter is specified, this function will additionally
   * check if the query is for one of the categories specified.
***************
*** 239,245 ****
  }
  
  /**
!  * Is the query for a tag archive page?
   *
   * If the $tag parameter is specified, this function will additionally
   * check if the query is for one of the tags specified.
--- 237,243 ----
  }
  
  /**
!  * Is the query for an existing tag archive page?
   *
   * If the $tag parameter is specified, this function will additionally
   * check if the query is for one of the tags specified.
***************
*** 263,269 ****
  }
  
  /**
!  * Is the query for a taxonomy archive page?
   *
   * If the $taxonomy parameter is specified, this function will additionally
   * check if the query is for that specific $taxonomy.
--- 261,267 ----
  }
  
  /**
!  * Is the query for an existing taxonomy archive page?
   *
   * If the $taxonomy parameter is specified, this function will additionally
   * check if the query is for that specific $taxonomy.
***************
*** 312,318 ****
  }
  
  /**
!  * Is the query for a date archive?
   *
   * @see WP_Query::is_date()
   * @since 1.5.0
--- 310,316 ----
  }
  
  /**
!  * Is the query for an existing date archive?
   *
   * @see WP_Query::is_date()
   * @since 1.5.0
***************
*** 332,338 ****
  }
  
  /**
!  * Is the query for a day archive?
   *
   * @see WP_Query::is_day()
   * @since 1.5.0
--- 330,336 ----
  }
  
  /**
!  * Is the query for an existing day archive?
   *
   * @see WP_Query::is_day()
   * @since 1.5.0
***************
*** 452,458 ****
  }
  
  /**
!  * Is the query for a month archive?
   *
   * @see WP_Query::is_month()
   * @since 1.5.0
--- 450,456 ----
  }
  
  /**
!  * Is the query for an existing month archive?
   *
   * @see WP_Query::is_month()
   * @since 1.5.0
***************
*** 472,478 ****
  }
  
  /**
!  * Is the query for a single page?
   *
   * If the $page parameter is specified, this function will additionally
   * check if the query is for one of the pages specified.
--- 470,476 ----
  }
  
  /**
!  * Is the query for an existing single page?
   *
   * If the $page parameter is specified, this function will additionally
   * check if the query is for one of the pages specified.
***************
*** 579,585 ****
  }
  
  /**
!  * Is the query for a single post?
   *
   * Works for any post type, except attachments and pages
   *
--- 577,583 ----
  }
  
  /**
!  * Is the query for an existing single post?
   *
   * Works for any post type, except attachments and pages
   *
***************
*** 608,614 ****
  }
  
  /**
!  * Is the query for a single post of any post type (post, attachment, page, ... )?
   *
   * If the $post_types parameter is specified, this function will additionally
   * check if the query is for one of the Posts Types specified.
--- 606,612 ----
  }
  
  /**
!  * Is the query for an existing single post of any post type (post, attachment, page, ... )?
   *
   * If the $post_types parameter is specified, this function will additionally
   * check if the query is for one of the Posts Types specified.
***************
*** 675,681 ****
  }
  
  /**
!  * Is the query for a specific year?
   *
   * @see WP_Query::is_year()
   * @since 1.5.0
--- 673,679 ----
  }
  
  /**
!  * Is the query for an existing year archive?
   *
   * @see WP_Query::is_year()
   * @since 1.5.0
***************
*** 979,985 ****
  	var $comment;
  
  	/**
! 	 * Amount of posts if limit clause was not used.
  	 *
  	 * @since 2.1.0
  	 * @access public
--- 977,985 ----
  	var $comment;
  
  	/**
! 	 * The amount of found posts for the current query.
! 	 *
! 	 * If limit clause was not used, equals $post_count.
  	 *
  	 * @since 2.1.0
  	 * @access public
***************
*** 1398,1403 ****
--- 1398,1404 ----
  			, 's'
  			, 'sentence'
  			, 'fields'
+ 			, 'menu_order'
  		);
  
  		foreach ( $keys as $key ) {
***************
*** 1452,1457 ****
--- 1453,1459 ----
  		if ( '' !== $qv['hour'] ) $qv['hour'] = absint($qv['hour']);
  		if ( '' !== $qv['minute'] ) $qv['minute'] = absint($qv['minute']);
  		if ( '' !== $qv['second'] ) $qv['second'] = absint($qv['second']);
+ 		if ( '' !== $qv['menu_order'] ) $qv['menu_order'] = absint($qv['menu_order']);
  
  		// Compat. Map subpost to attachment.
  		if ( '' != $qv['subpost'] )
***************
*** 1785,1797 ****
  		// Tag stuff
  		if ( '' != $q['tag'] && !$this->is_singular && $this->query_vars_changed ) {
  			if ( strpos($q['tag'], ',') !== false ) {
! 				$tags = preg_split('/[,\s]+/', $q['tag']);
  				foreach ( (array) $tags as $tag ) {
  					$tag = sanitize_term_field('slug', $tag, 0, 'post_tag', 'db');
  					$q['tag_slug__in'][] = $tag;
  				}
! 			} else if ( preg_match('/[+\s]+/', $q['tag']) || !empty($q['cat']) ) {
! 				$tags = preg_split('/[+\s]+/', $q['tag']);
  				foreach ( (array) $tags as $tag ) {
  					$tag = sanitize_term_field('slug', $tag, 0, 'post_tag', 'db');
  					$q['tag_slug__and'][] = $tag;
--- 1787,1799 ----
  		// Tag stuff
  		if ( '' != $q['tag'] && !$this->is_singular && $this->query_vars_changed ) {
  			if ( strpos($q['tag'], ',') !== false ) {
! 				$tags = preg_split('/[,\r\n\t ]+/', $q['tag']);
  				foreach ( (array) $tags as $tag ) {
  					$tag = sanitize_term_field('slug', $tag, 0, 'post_tag', 'db');
  					$q['tag_slug__in'][] = $tag;
  				}
! 			} else if ( preg_match('/[+\r\n\t ]+/', $q['tag']) || !empty($q['cat']) ) {
! 				$tags = preg_split('/[+\r\n\t ]+/', $q['tag']);
  				foreach ( (array) $tags as $tag ) {
  					$tag = sanitize_term_field('slug', $tag, 0, 'post_tag', 'db');
  					$q['tag_slug__and'][] = $tag;
***************
*** 1914,1920 ****
  	 *
  	 * @return array List of posts.
  	 */
! 	function &get_posts() {
  		global $wpdb, $user_ID, $_wp_using_ext_object_cache;
  
  		$this->parse_query();
--- 1916,1922 ----
  	 *
  	 * @return array List of posts.
  	 */
! 	function get_posts() {
  		global $wpdb, $user_ID, $_wp_using_ext_object_cache;
  
  		$this->parse_query();
***************
*** 2040,2045 ****
--- 2042,2050 ----
  				$fields = "$wpdb->posts.*";
  		}
  
+ 		if ( '' !== $q['menu_order'] )
+ 			$where .= " AND $wpdb->posts.menu_order = " . $q['menu_order'];
+ 
  		// If a month is specified in the querystring, load that month
  		if ( $q['m'] ) {
  			$q['m'] = '' . preg_replace('|[^0-9]|', '', $q['m']);
***************
*** 2128,2134 ****
  				$q['pagename'] = sanitize_title_for_query( wp_basename( $q['pagename'] ) );
  				$q['name'] = $q['pagename'];
  				$where .= " AND ($wpdb->posts.ID = '$reqpage')";
! 				$reqpage_obj = get_page($reqpage);
  				if ( is_object($reqpage_obj) && 'attachment' == $reqpage_obj->post_type ) {
  					$this->is_attachment = true;
  					$post_type = $q['post_type'] = 'attachment';
--- 2133,2139 ----
  				$q['pagename'] = sanitize_title_for_query( wp_basename( $q['pagename'] ) );
  				$q['name'] = $q['pagename'];
  				$where .= " AND ($wpdb->posts.ID = '$reqpage')";
! 				$reqpage_obj = get_post( $reqpage );
  				if ( is_object($reqpage_obj) && 'attachment' == $reqpage_obj->post_type ) {
  					$this->is_attachment = true;
  					$post_type = $q['post_type'] = 'attachment';
***************
*** 2177,2182 ****
--- 2182,2189 ----
  		if ( !empty($q['s']) ) {
  			// added slashes screw with quote grouping when done early, so done later
  			$q['s'] = stripslashes($q['s']);
+ 			if ( empty( $_GET['s'] ) && $this->is_main_query() )
+ 				$q['s'] = urldecode($q['s']);
  			if ( !empty($q['sentence']) ) {
  				$q['search_terms'] = array($q['s']);
  			} else {
***************
*** 2213,2219 ****
  
  		if ( $this->is_tax ) {
  			if ( empty($post_type) ) {
! 				$post_type = 'any';
  				$post_status_join = true;
  			} elseif ( in_array('attachment', (array) $post_type) ) {
  				$post_status_join = true;
--- 2220,2236 ----
  
  		if ( $this->is_tax ) {
  			if ( empty($post_type) ) {
! 				// Do a fully inclusive search for currently registered post types of queried taxonomies
! 				$post_type = array();
! 				$taxonomies = wp_list_pluck( $this->tax_query->queries, 'taxonomy' );
! 				foreach ( get_post_types( array( 'exclude_from_search' => false ) ) as $pt ) {
! 					$object_taxonomies = $pt === 'attachment' ? get_taxonomies_for_attachments() : get_object_taxonomies( $pt );
! 					if ( array_intersect( $taxonomies, $object_taxonomies ) )
! 						$post_type[] = $pt;
! 				}
! 				if ( ! $post_type )
! 					$post_type = 'any';
! 
  				$post_status_join = true;
  			} elseif ( in_array('attachment', (array) $post_type) ) {
  				$post_status_join = true;
***************
*** 2324,2329 ****
--- 2341,2348 ----
  			$orderby = "$wpdb->posts.post_date " . $q['order'];
  		} elseif ( 'none' == $q['orderby'] ) {
  			$orderby = '';
+ 		} elseif ( $q['orderby'] == 'post__in' && ! empty( $post__in ) ) {
+ 			$orderby = "FIELD( {$wpdb->posts}.ID, $post__in )";
  		} else {
  			// Used to filter values
  			$allowed_keys = array('name', 'author', 'date', 'title', 'modified', 'menu_order', 'parent', 'ID', 'rand', 'comment_count');
***************
*** 2386,2392 ****
  		if ( 'any' == $post_type ) {
  			$in_search_post_types = get_post_types( array('exclude_from_search' => false) );
  			if ( ! empty( $in_search_post_types ) )
! 				$where .= $wpdb->prepare(" AND $wpdb->posts.post_type IN ('" . join("', '", $in_search_post_types ) . "')");
  		} elseif ( !empty( $post_type ) && is_array( $post_type ) ) {
  			$where .= " AND $wpdb->posts.post_type IN ('" . join("', '", $post_type) . "')";
  		} elseif ( ! empty( $post_type ) ) {
--- 2405,2411 ----
  		if ( 'any' == $post_type ) {
  			$in_search_post_types = get_post_types( array('exclude_from_search' => false) );
  			if ( ! empty( $in_search_post_types ) )
! 				$where .= " AND $wpdb->posts.post_type IN ('" . join("', '", $in_search_post_types ) . "')";
  		} elseif ( !empty( $post_type ) && is_array( $post_type ) ) {
  			$where .= " AND $wpdb->posts.post_type IN ('" . join("', '", $post_type) . "')";
  		} elseif ( ! empty( $post_type ) ) {
***************
*** 2612,2624 ****
  		}
  
  		if ( 'ids' == $q['fields'] ) {
! 			$this->posts = $wpdb->get_col($this->request);
  
  			return $this->posts;
  		}
  
  		if ( 'id=>parent' == $q['fields'] ) {
! 			$this->posts = $wpdb->get_results($this->request);
  
  			$r = array();
  			foreach ( $this->posts as $post )
--- 2631,2647 ----
  		}
  
  		if ( 'ids' == $q['fields'] ) {
! 			$this->posts = $wpdb->get_col( $this->request );
! 			$this->post_count = count( $this->posts );
! 			$this->set_found_posts( $q, $limits );
  
  			return $this->posts;
  		}
  
  		if ( 'id=>parent' == $q['fields'] ) {
! 			$this->posts = $wpdb->get_results( $this->request );
! 			$this->post_count = count( $this->posts );
! 			$this->set_found_posts( $q, $limits );
  
  			$r = array();
  			foreach ( $this->posts as $post )
***************
*** 2640,2652 ****
  			$ids = $wpdb->get_col( $this->request );
  
  			if ( $ids ) {
  				$this->set_found_posts( $q, $limits );
- 
  				_prime_post_caches( $ids, $q['update_post_term_cache'], $q['update_post_meta_cache'] );
- 
- 				$this->posts = array_map( 'get_post', $ids );
  			} else {
- 				$this->found_posts = $this->max_num_pages = 0;
  				$this->posts = array();
  			}
  		} else {
--- 2663,2672 ----
  			$ids = $wpdb->get_col( $this->request );
  
  			if ( $ids ) {
+ 				$this->posts = $ids;
  				$this->set_found_posts( $q, $limits );
  				_prime_post_caches( $ids, $q['update_post_term_cache'], $q['update_post_meta_cache'] );
  			} else {
  				$this->posts = array();
  			}
  		} else {
***************
*** 2654,2659 ****
--- 2674,2683 ----
  			$this->set_found_posts( $q, $limits );
  		}
  
+ 		// Convert to WP_Post objects
+ 		if ( $this->posts )
+ 			$this->posts = array_map( 'get_post', $this->posts );
+ 
  		// Raw results filter. Prior to status checks.
  		if ( !$q['suppress_filters'] )
  			$this->posts = apply_filters_ref_array('posts_results', array( $this->posts, &$this ) );
***************
*** 2700,2706 ****
  			}
  
  			if ( $this->is_preview && $this->posts && current_user_can( $edit_cap, $this->posts[0]->ID ) )
! 				$this->posts[0] = apply_filters_ref_array('the_preview', array( $this->posts[0], &$this ));
  		}
  
  		// Put sticky posts at the top of the posts array
--- 2724,2730 ----
  			}
  
  			if ( $this->is_preview && $this->posts && current_user_can( $edit_cap, $this->posts[0]->ID ) )
! 				$this->posts[0] = get_post( apply_filters_ref_array( 'the_preview', array( $this->posts[0], &$this ) ) );
  		}
  
  		// Put sticky posts at the top of the posts array
***************
*** 2730,2753 ****
  
  			// Fetch sticky posts that weren't in the query results
  			if ( !empty($sticky_posts) ) {
! 				$stickies__in = implode(',', array_map( 'absint', $sticky_posts ));
! 				// honor post type(s) if not set to any
! 				$stickies_where = '';
! 				if ( 'any' != $post_type && '' != $post_type ) {
! 					if ( is_array( $post_type ) ) {
! 						$post_types = join( "', '", $post_type );
! 					} else {
! 						$post_types = $post_type;
! 					}
! 					$stickies_where = "AND $wpdb->posts.post_type IN ('" . $post_types . "')";
! 				}
  
- 				$stickies = $wpdb->get_results( "SELECT * FROM $wpdb->posts WHERE $wpdb->posts.ID IN ($stickies__in) $stickies_where" );
  				foreach ( $stickies as $sticky_post ) {
! 					// Ignore sticky posts the current user cannot read or are not published.
! 					if ( 'publish' != $sticky_post->post_status )
! 						continue;
! 					array_splice($this->posts, $sticky_offset, 0, array($sticky_post));
  					$sticky_offset++;
  				}
  			}
--- 2754,2768 ----
  
  			// Fetch sticky posts that weren't in the query results
  			if ( !empty($sticky_posts) ) {
! 				$stickies = get_posts( array(
! 					'post__in' => $sticky_posts,
! 					'post_type' => $post_type,
! 					'post_status' => 'publish',
! 					'nopaging' => true
! 				) );
  
  				foreach ( $stickies as $sticky_post ) {
! 					array_splice( $this->posts, $sticky_offset, 0, array( $sticky_post ) );
  					$sticky_offset++;
  				}
  			}
***************
*** 2756,2788 ****
  		if ( !$q['suppress_filters'] )
  			$this->posts = apply_filters_ref_array('the_posts', array( $this->posts, &$this ) );
  
! 		$this->post_count = count($this->posts);
  
! 		// Always sanitize
! 		foreach ( $this->posts as $i => $post ) {
! 			$this->posts[$i] = sanitize_post( $post, 'raw' );
! 		}
  
! 		if ( $q['cache_results'] )
! 			update_post_caches($this->posts, $post_type, $q['update_post_term_cache'], $q['update_post_meta_cache']);
  
! 		if ( $this->post_count > 0 ) {
! 			$this->post = $this->posts[0];
  		}
  
  		return $this->posts;
  	}
  
  	function set_found_posts( $q, $limits ) {
  		global $wpdb;
  
! 		if ( $q['no_found_rows'] || empty( $limits ) )
  			return;
  
! 		$this->found_posts = $wpdb->get_var( apply_filters_ref_array( 'found_posts_query', array( 'SELECT FOUND_ROWS()', &$this ) ) );
  		$this->found_posts = apply_filters_ref_array( 'found_posts', array( $this->found_posts, &$this ) );
  
! 		$this->max_num_pages = ceil( $this->found_posts / $q['posts_per_page'] );
  	}
  
  	/**
--- 2771,2819 ----
  		if ( !$q['suppress_filters'] )
  			$this->posts = apply_filters_ref_array('the_posts', array( $this->posts, &$this ) );
  
! 		// Ensure that any posts added/modified via one of the filters above are
! 		// of the type WP_Post and are filtered.
! 		if ( $this->posts ) {
! 			$this->post_count = count( $this->posts );
  
! 			$this->posts = array_map( 'get_post', $this->posts );
  
! 			if ( $q['cache_results'] )
! 				update_post_caches($this->posts, $post_type, $q['update_post_term_cache'], $q['update_post_meta_cache']);
  
! 			$this->post = reset( $this->posts );
! 		} else {
! 			$this->post_count = 0;
! 			$this->posts = array();
  		}
  
  		return $this->posts;
  	}
  
+ 	/**
+ 	 * Set up the amount of found posts and the number of pages (if limit clause was used)
+ 	 * for the current query.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access private
+ 	 */
  	function set_found_posts( $q, $limits ) {
  		global $wpdb;
  
! 		// Bail if posts is an empty array. Continue if posts is an empty string
! 		// null, or false to accommodate caching plugins that fill posts later.
! 		if ( $q['no_found_rows'] || ( is_array( $this->posts ) && ! $this->posts ) )
  			return;
  
! 		if ( ! empty( $limits ) )
! 			$this->found_posts = $wpdb->get_var( apply_filters_ref_array( 'found_posts_query', array( 'SELECT FOUND_ROWS()', &$this ) ) );
! 		else
! 			$this->found_posts = count( $this->posts );
! 
  		$this->found_posts = apply_filters_ref_array( 'found_posts', array( $this->found_posts, &$this ) );
  
! 		if ( ! empty( $limits ) )
! 			$this->max_num_pages = ceil( $this->found_posts / $q['posts_per_page'] );
  	}
  
  	/**
***************
*** 2791,2797 ****
  	 * @since 1.5.0
  	 * @access public
  	 *
! 	 * @return object Next post.
  	 */
  	function next_post() {
  
--- 2822,2828 ----
  	 * @since 1.5.0
  	 * @access public
  	 *
! 	 * @return WP_Post Next post.
  	 */
  	function next_post() {
  
***************
*** 2935,2941 ****
  	 * @param string $query URL query string.
  	 * @return array List of posts.
  	 */
! 	function &query( $query ) {
  		$this->init();
  		$this->query = $this->query_vars = wp_parse_args( $query );
  		return $this->get_posts();
--- 2966,2972 ----
  	 * @param string $query URL query string.
  	 * @return array List of posts.
  	 */
! 	function query( $query ) {
  		$this->init();
  		$this->query = $this->query_vars = wp_parse_args( $query );
  		return $this->get_posts();
***************
*** 2967,2976 ****
  
  			if ( 'term_id' == $query['field'] )
  				$term = get_term( reset( $query['terms'] ), $query['taxonomy'] );
! 			else
  				$term = get_term_by( $query['field'], reset( $query['terms'] ), $query['taxonomy'] );
  
! 			if ( $term && ! is_wp_error($term) )  {
  				$this->queried_object = $term;
  				$this->queried_object_id = (int) $term->term_id;
  
--- 2998,3007 ----
  
  			if ( 'term_id' == $query['field'] )
  				$term = get_term( reset( $query['terms'] ), $query['taxonomy'] );
! 			elseif ( $query['terms'] )
  				$term = get_term_by( $query['field'], reset( $query['terms'] ), $query['taxonomy'] );
  
! 			if ( ! empty( $term ) && ! is_wp_error( $term ) )  {
  				$this->queried_object = $term;
  				$this->queried_object_id = (int) $term->term_id;
  
***************
*** 2981,2987 ****
  			$this->queried_object = get_post_type_object( $this->get('post_type') );
  		} elseif ( $this->is_posts_page ) {
  			$page_for_posts = get_option('page_for_posts');
! 			$this->queried_object = get_page( $page_for_posts );
  			$this->queried_object_id = (int) $this->queried_object->ID;
  		} elseif ( $this->is_singular && !is_null($this->post) ) {
  			$this->queried_object = $this->post;
--- 3012,3018 ----
  			$this->queried_object = get_post_type_object( $this->get('post_type') );
  		} elseif ( $this->is_posts_page ) {
  			$page_for_posts = get_option('page_for_posts');
! 			$this->queried_object = get_post( $page_for_posts );
  			$this->queried_object_id = (int) $this->queried_object->ID;
  		} elseif ( $this->is_singular && !is_null($this->post) ) {
  			$this->queried_object = $this->post;
***************
*** 3030,3036 ****
  	}
  
  	/**
!  	 * Is the query for an archive page?
   	 *
   	 * Month, Year, Category, Author, Post Type archive...
  	 *
--- 3061,3067 ----
  	}
  
  	/**
!  	 * Is the query for an existing archive page?
   	 *
   	 * Month, Year, Category, Author, Post Type archive...
  	 *
***************
*** 3043,3049 ****
  	}
  
  	/**
! 	 * Is the query for a post type archive page?
  	 *
  	 * @since 3.1.0
  	 *
--- 3074,3080 ----
  	}
  
  	/**
! 	 * Is the query for an existing post type archive page?
  	 *
  	 * @since 3.1.0
  	 *
***************
*** 3060,3066 ****
  	}
  
  	/**
! 	 * Is the query for an attachment page?
  	 *
  	 * @since 3.1.0
  	 *
--- 3091,3097 ----
  	}
  
  	/**
! 	 * Is the query for an existing attachment page?
  	 *
  	 * @since 3.1.0
  	 *
***************
*** 3071,3077 ****
  	}
  
  	/**
! 	 * Is the query for an author archive page?
  	 *
  	 * If the $author parameter is specified, this function will additionally
  	 * check if the query is for one of the authors specified.
--- 3102,3108 ----
  	}
  
  	/**
! 	 * Is the query for an existing author archive page?
  	 *
  	 * If the $author parameter is specified, this function will additionally
  	 * check if the query is for one of the authors specified.
***************
*** 3103,3109 ****
  	}
  
  	/**
! 	 * Is the query for a category archive page?
  	 *
  	 * If the $category parameter is specified, this function will additionally
  	 * check if the query is for one of the categories specified.
--- 3134,3140 ----
  	}
  
  	/**
! 	 * Is the query for an existing category archive page?
  	 *
  	 * If the $category parameter is specified, this function will additionally
  	 * check if the query is for one of the categories specified.
***************
*** 3135,3141 ****
  	}
  
  	/**
! 	 * Is the query for a tag archive page?
  	 *
  	 * If the $tag parameter is specified, this function will additionally
  	 * check if the query is for one of the tags specified.
--- 3166,3172 ----
  	}
  
  	/**
! 	 * Is the query for an existing tag archive page?
  	 *
  	 * If the $tag parameter is specified, this function will additionally
  	 * check if the query is for one of the tags specified.
***************
*** 3163,3169 ****
  	}
  
  	/**
! 	 * Is the query for a taxonomy archive page?
  	 *
  	 * If the $taxonomy parameter is specified, this function will additionally
  	 * check if the query is for that specific $taxonomy.
--- 3194,3200 ----
  	}
  
  	/**
! 	 * Is the query for an existing taxonomy archive page?
  	 *
  	 * If the $taxonomy parameter is specified, this function will additionally
  	 * check if the query is for that specific $taxonomy.
***************
*** 3191,3198 ****
  		$tax_array = array_intersect( array_keys( $wp_taxonomies ), (array) $taxonomy );
  		$term_array = (array) $term;
  
! 		if ( empty( $term ) ) // Only a Taxonomy provided
! 			return isset( $queried_object->taxonomy ) && count( $tax_array ) && in_array( $queried_object->taxonomy, $tax_array );
  
  		return isset( $queried_object->term_id ) &&
  			count( array_intersect(
--- 3222,3234 ----
  		$tax_array = array_intersect( array_keys( $wp_taxonomies ), (array) $taxonomy );
  		$term_array = (array) $term;
  
! 		// Check that the taxonomy matches.
! 		if ( ! ( isset( $queried_object->taxonomy ) && count( $tax_array ) && in_array( $queried_object->taxonomy, $tax_array ) ) )
! 			return false;
! 
! 		// Only a Taxonomy provided.
! 		if ( empty( $term ) )
! 			return true;
  
  		return isset( $queried_object->term_id ) &&
  			count( array_intersect(
***************
*** 3213,3219 ****
  	}
  
  	/**
! 	 * Is the query for a date archive?
  	 *
  	 * @since 3.1.0
  	 *
--- 3249,3255 ----
  	}
  
  	/**
! 	 * Is the query for an existing date archive?
  	 *
  	 * @since 3.1.0
  	 *
***************
*** 3224,3230 ****
  	}
  
  	/**
! 	 * Is the query for a day archive?
  	 *
  	 * @since 3.1.0
  	 *
--- 3260,3266 ----
  	}
  
  	/**
! 	 * Is the query for an existing day archive?
  	 *
  	 * @since 3.1.0
  	 *
***************
*** 3311,3317 ****
  	}
  
  	/**
! 	 * Is the query for a month archive?
  	 *
  	 * @since 3.1.0
  	 *
--- 3347,3353 ----
  	}
  
  	/**
! 	 * Is the query for an existing month archive?
  	 *
  	 * @since 3.1.0
  	 *
***************
*** 3322,3328 ****
  	}
  
  	/**
! 	 * Is the query for a single page?
  	 *
  	 * If the $page parameter is specified, this function will additionally
  	 * check if the query is for one of the pages specified.
--- 3358,3364 ----
  	}
  
  	/**
! 	 * Is the query for an existing single page?
  	 *
  	 * If the $page parameter is specified, this function will additionally
  	 * check if the query is for one of the pages specified.
***************
*** 3401,3407 ****
  	}
  
  	/**
! 	 * Is the query for a single post?
  	 *
  	 * Works for any post type, except attachments and pages
  	 *
--- 3437,3443 ----
  	}
  
  	/**
! 	 * Is the query for an existing single post?
  	 *
  	 * Works for any post type, except attachments and pages
  	 *
***************
*** 3438,3444 ****
  	}
  
  	/**
! 	 * Is the query for a single post of any post type (post, attachment, page, ... )?
  	 *
  	 * If the $post_types parameter is specified, this function will additionally
  	 * check if the query is for one of the Posts Types specified.
--- 3474,3480 ----
  	}
  
  	/**
! 	 * Is the query for an existing single post of any post type (post, attachment, page, ... )?
  	 *
  	 * If the $post_types parameter is specified, this function will additionally
  	 * check if the query is for one of the Posts Types specified.
***************
*** 3483,3489 ****
  	}
  
  	/**
! 	 * Is the query for a specific year?
  	 *
  	 * @since 3.1.0
  	 *
--- 3519,3525 ----
  	}
  
  	/**
! 	 * Is the query for an existing year archive?
  	 *
  	 * @since 3.1.0
  	 *
